# app.py
import grok
from grok import index
from hurry import query
from hurry.query.query import Query, Text
from interfaces import IProtonObject
from protonobject import ProtonObject

# hurry.query is a simplified search query language that
# allows you to create ANDs and ORs.


class TimSearch(grok.Application, grok.Container):
    """The app."""
    pass


import random

_chars = u'abcdefghijklmnopqrstuvwxyzåäö'
_words = ('what', 'how', 'when', 'where')
def yabber(length):
    outp = []
    first_word = True
    for i in range(length - 1):
        word = []
        for n in range(random.randint(3, 15)):
            word.append(random.choice(_chars))
        word = "".join(word)
        if first_word:
            first_word = False
            outp.append(word.title())
        elif random.randint(1,10) == 5:
            outp.append( u"%s." % word)
            first_word = True
        else:
            outp.append(word)
    
    outp.append(random.choice(_words))
    return " ".join(outp)
    
    
from random import randint
class AddObjects(grok.View):
    def render(self, x = 10):
        s = grok.getSite()
        id = None
        for n in range(x):
            while id is None or s.has_key(id):
                id = "obj_%s" % randint(10000, 99999)
            body = yabber(30)
            s[id] = ProtonObject(body=body)
        return "Done... %s objects" % x
        

class ContentIndexes(grok.Indexes):
    """
    This is where I setup my indexes. I have two indexes;
    one full-text index called "text_body",
    one field index called "body".
    """
    grok.site(TimSearch)

    grok.context(IProtonObject)
    # grok.context() tells Grok that objects implementing
    # the interface IProtonObject should be indexed.

    grok.name('proton_catalog')
    # grok.name() tells Grok what to call the catalog.
    # if you have named the catalog anything but "catalog"
    # you need to specify the name of the catalog in your
    # queries.

    text_body = index.Text(attribute='body')
    body = index.Field(attribute='body')
    # The attribute='body' parameter is actually unnecessary if the attribute to
    # be indexed has the same name as the index.

class Index(grok.View):
    grok.context(TimSearch)

class ProtonSearch(grok.View):
    grok.context(TimSearch)
    
    def update(self, search=""):
        if len(search) > 1:
            self.field_searcg, self.text_search = self.search_content(search) 

    def search_content(self, search_query):
            # The following query does a search on the field index "body".
            # It will return a list of object where the entire content of the body attribute
            # matches the search term exactly. I.e. search_query == body
            result_a = Query().searchResults(
                               query.Eq(('proton_catalog', 'body'), search_query)
                               )

            # The following query does a search on the full-text index "text_body".
            # It will return objects that match the search_query. You can use wildcards and
            # boolean operators.
            #
            # Examples:
            # "grok AND zope" returns objects where "body" contains the words "grok" and "zope"
            # "grok or dev*" returns objects where "body" contains the word "grok" or any word
            # beginning with "dev"
            result_b = Query().searchResults(
                               Text( ('proton_catalog', 'text_body'), search_query)
                               )

            return result_a, result_b
